/* Chapter 3. cat. */
/* cat [options] [files]
	Only the -s option is used. Others are ignored.
	-s suppresses error report when a file does not exist */

#include "EvryThng.h"

#define BUF_SIZE 0x200

static VOID CatFile (HANDLE, HANDLE);
int _tmain (int argc, LPTSTR argv [])
{
	HANDLE hInFile, hStdIn = GetStdHandle (/*??*/);
	HANDLE hStdOut = GetStdHandle (/*??*/);
	BOOL DashS;
	int iArg, iFirstFile;

	/*  Determine the option (DashS) and the location of the
		first file in the command line. */

	iFirstFile = Options (argc, argv, _T ("s"), &DashS, NULL);

	if (iFirstFile == argc) { /* No files in arg list. */
		CatFile (hStdIn, hStdOut);
		return 0;
	} 

	for (iArg = iFirstFile; iArg < argc; iArg++) {
		hInFile = CreateFile (/*??*/, /*??*/,
				0, NULL, /*??*/G, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hInFile == /*??*/ && !DashS)
			ReportError (_T ("Cat Error: File does not exist."), 1, TRUE);
		CatFile (hInFile, hStdOut);
		CloseHandle (/*??*/);
	}
	return 0;
}

static VOID CatFile (HANDLE hInFile, HANDLE hOutFile)
{
	DWORD nIn, nOut;
	BYTE Buffer [BUF_SIZE];

	while (ReadFile (/*??*/, Buffer, BUF_SIZE, &nIn, NULL) && (nIn != /*??*/)
			&& WriteFile (hOutFile, Buffer, /*??*/, &nOut, NULL));

	return;
}
