/* Chapter 12. catDL - DLL version. */
/* cat [options] [files]
	Only the -s option is used. Others are ignored. */

#include "EvryThng.h"

#define BUF_SIZE 0x200

static VOID CatFile (HANDLE, HANDLE);
/*??*/ mainDLL (int argc, LPTSTR argv [], HANDLE /*??*/)
{
	/*??*/ hInFile;

	/* This is threaded code, so we cannot use the process
		standard handles. Use handles specific to the thread. */

	/* HANDLE hStdOut = GetStdHandle (STD_OUTPUT_HANDLE); */

	BOOL DashS;
	int iArg, iFirstFile;

	/* Determine the option (DashS) and the location
		of the first file in the command line. */

	iFirstFile = Options (argc, argv, _T ("s"), &DashS, NULL);

	if (iFirstFile == /*??*/) { /* No files in arg list. */
		return 1;  /* Error - DLL/thread cannot use stdin. */
	} 

	for (iArg = iFirstFile; iArg < argc; iArg++) {
		hInFile = CreateFile (argv [iArg], GENERIC_READ,
				0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hInFile == INVALID_HANDLE_VALUE && DashS)
			ReportError (_T ("\nCat Error: File does not exist."), 1, TRUE);
		CatFile (hInFile, hStdOut);
	}
	CloseHandle (hInFile);
	return 0;
}

static VOID CatFile (HANDLE hInFile, HANDLE hOutFile)
{
	DWORD nIn, nOut;
	BYTE Buffer [BUF_SIZE];

	while (ReadFile (hInFile, Buffer, BUF_SIZE, &nIn, NULL)
			&& (nIn /*??*/)
			&& WriteFile (hOutFile, Buffer, nIn, &nOut, NULL));

	return;
}
